commit d9dfbd19d7700cd0e2f033cb60ae849574ff8c12
Author: Serghei Mihai <smihai@entrouvert.com>
Date:   Tue Apr 28 11:56:38 2015 +0200

    users creation form(#7065)

diff --git a/MANIFEST.in b/MANIFEST.in
index 112f36b..6c0762d 100644
--- a/MANIFEST.in
+++ b/MANIFEST.in
@@ -2,5 +2,5 @@ include MANIFEST.in
 include README
 include COPYING
 recursive-include uauth/templates *.html
-recursive-include uauth/static *.css *.js
+recursive-include uauth/static *.css *.js *.png
 
diff --git a/uauth/organization/urls.py b/uauth/organization/urls.py
index 6cf4dfd..ed4d1d8 100644
--- a/uauth/organization/urls.py
+++ b/uauth/organization/urls.py
@@ -5,4 +5,5 @@ from .views import *
 urlpatterns = patterns('',
     url(r'^$', manage, name='manage'),
     url(r'^users/?$', users, name='manage-users'),
+    url(r'^users/create$', create_users, name='create-users'),
 )
diff --git a/uauth/organization/utils.py b/uauth/organization/utils.py
new file mode 100644
index 0000000..e59425c
--- /dev/null
+++ b/uauth/organization/utils.py
@@ -0,0 +1,20 @@
+import random
+
+from django.contrib.auth.hashers import make_password
+
+from .models import LocalAccount
+
+
+def create_password():
+    return ''.join([random.choice('23456789ABCDEFGHJLMNPQRSTUVWXZabcdefghjkmnpqrstuvwxyz')
+                for x in range(random.randint(6,9))])
+
+
+def create_user(data):
+    if not data['password']:
+        data['password'] = create_password()
+    try:
+        user = LocalAccount.objects.create(**data)
+        return user
+    except:
+        return False
diff --git a/uauth/organization/views.py b/uauth/organization/views.py
index e940311..3175cd6 100644
--- a/uauth/organization/views.py
+++ b/uauth/organization/views.py
@@ -3,10 +3,14 @@ from django.core.urlresolvers import reverse_lazy
 
 from django.views.generic.base import TemplateView
 from django.views.generic.list import ListView
+from django.views.generic.edit import FormView
+from django.contrib import messages
 
 from django_tables2 import RequestConfig
 
+from .utils import create_user
 from .models import LocalAccount, Organization
+from .forms import LocalAccountCreateForm
 from .tables import AccountTable
 
 
@@ -41,3 +45,33 @@ class UsersPageView(OrganizationMixin, ListView):
         return context
 
 users = UsersPageView.as_view()
+
+
+class UsersCreateView(OrganizationMixin, FormView):
+    template_name = 'organization/create-users.html'
+    form_class = LocalAccountCreateForm
+
+    def form_valid(self, form):
+        data = form.cleaned_data
+        data['organization'] = Organization.objects.get(slug=self.kwargs['organization_slug'])
+        accounts_number = data.pop('accounts_number')
+        accounts_number_start = data.pop('accounts_number_start')
+        if accounts_number_start < 1:
+            accounts_number_start = 0
+
+        username = data['username']
+        if accounts_number > 1:
+            for index in xrange(accounts_number_start, accounts_number + accounts_number_start):
+                data['username'] = '%s-%s' % (username, index)
+                if not create_user(data):
+                    messages.error(self, request, _('Error while creating user %s' % data['username']))
+                    break
+            messages.info(self.request, _('%s users added successfully' % accounts_number))
+        else:
+            if create_user(data):
+                messages.info(self.request, _('User "%s" successfully created' % data['username']))
+            else:
+                messages.error(self.request, _('Error occured while creating user "%s"' % data['username']))
+        return super(UsersCreateView, self).form_valid(form)
+
+create_users = UsersCreateView.as_view()
